<?php // Silence is golden
global $wpdb;
if(isset($_POST['save_list'])){
	$ts_traffic_lists = $wpdb->prefix . 'ls_traffic_lists';
    $insert = array(
				'name'   => $_POST['name'],			
				'description'=> $_POST['description'],
                'updated_at'=> date('Y-m-d-H:i:s'),				
				'created_at'=> date('Y-m-d-H:i:s'),	
	          );
	try{
		$resp =  $wpdb->insert($ts_traffic_lists,$insert);
		if($wpdb->insert_id) {
			$post_id= $wpdb->insert_id;
			//ts_save_video_to_server($post_id);
			//echo 'success';
			echo'<div class="alert alert-success">List saved successfully</div>';
		}else{
			//print_r($wpdb->last_error);
			echo'<div class="alert alert-danger">'.$wpdb->print_error().'</div>';
			//echo $wpdb->print_error();
		}
	}catch(\Exception $e){
		//print_r($e->getMessage());
		echo'<div class="alert alert-danger">'.$e->getMessage().'</div>';
		//die('ERROR');
	}	
}

if(isset($_POST['update_list'])){
	$ts_traffic_lists = $wpdb->prefix . 'ls_traffic_lists';
    $data = array(
				'name'   => $_POST['name'],			
				'description'=> $_POST['description'],
	          );
	$where = array('id'=>$_POST['listid']);		  
	try{
		$resp = $wpdb->update($ts_traffic_lists, $data, $where );
		if($resp) {
			echo'<div class="alert alert-success">List updated successfully</div>';
		}else{
			echo'<div class="alert alert-danger">'.$wpdb->print_error().'</div>';
		}
	}catch(\Exception $e){
		echo'<div class="alert alert-danger">'.$e->getMessage().'</div>';
	}	
}

if(isset($_POST['save_leads'])){
	
	$ts_traffic_leads = $wpdb->prefix . 'ls_traffic_leads';
	$message='';
	if(isset($_POST['emails']) && $_POST['emails']!=''){
		$emails = $_POST['emails'];
		//$emailss = explode(",",$emails);
		//echo"<pre>";print_r($emails);echo"</pre>";
		$emailss = explode(PHP_EOL, $emails);
		//echo"<pre>";print_r($_POST);echo"</pre>";

		foreach($emailss as $email){
		$email = trim($email);
		//echo"<pre>";print_r($email);echo"</pre>";
		//if (wphw_check_valid_email($email)) {
		if (filter_var($email, FILTER_VALIDATE_EMAIL)) {	
			//echo"<pre>";print_r($email);echo"</pre>";
			$insert = array(
						'email'   => $email,			
						'listid'  => $_POST['listid'],
						'updated_at'=> date('Y-m-d-H:i:s'),				
						'created_at'=> date('Y-m-d-H:i:s'),	
					  );
			try{
				
				$resp =  $wpdb->insert($ts_traffic_leads,$insert);
				if($resp) {
					//$post_id= $wpdb->insert_id;
					//ts_save_video_to_server($post_id);
					//echo 'success';
					$message .= '<div class="alert alert-success" style="padding:3px;margin: 0 0 3px;">'.$email.' saved successfully</div>';
				}else{
					//print_r($wpdb->last_error);
					$message .='<div class="alert alert-danger" style="padding:3px;margin: 0 0 3px;">'.$wpdb->print_error().'</div>';
					//echo $wpdb->print_error();
				}
			}catch(\Exception $e){
				//print_r($e->getMessage());
				$message .='<div class="alert alert-danger" style="padding:3px;margin: 0 0 3px;">'.$e->getMessage().'</div>';
				//die('ERROR');
			}	
		}else{
			$message .='<div class="alert alert-danger" style="padding:3px;margin: 0 0 3px;">Invalid Email:: '.$email.'</div>';
		}	
		}
	}
	
	if(isset($_FILES['emails_csv']) && $_FILES['emails_csv']!=''){
		$csv_mimetypes = array(
			'text/csv',
			'text/plain',
			'application/csv',
			'text/comma-separated-values',
			'application/excel',
			'application/vnd.ms-excel',
			'application/vnd.msexcel',
			'text/anytext',
			'application/octet-stream',
			'application/txt',
		);
        //echo"<pre>";print_r($_FILES['emails_csv']['type']);echo"</pre>";
		if (in_array($_FILES['emails_csv']['type'], $csv_mimetypes)) {
            $file = $_FILES['emails_csv']['tmp_name']; 
			$row = 1;
			if (($handle = fopen($file, "r")) !== FALSE) {
			    //echo"<pre>";print_r($file);echo"</pre>";
			    //echo"<pre>";print_r($handle);echo"</pre>";
			    while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
					$num = count($data);
					//echo "<p> $num fields in line $row: <br /></p>\n";
					$row++;
					for ($c=0; $c < $num; $c++) {
						//echo"<pre>";print_r($c);echo"</pre>";
						$email = $data[$c];
						$email = trim($email);
						if (filter_var($email, FILTER_VALIDATE_EMAIL)) {	
							
							
							//echo"<pre>";print_r($email);echo"</pre>";
							$insert = array(
										'email'   => $email,			
										'listid'  => $_POST['listid'],
										'updated_at'=> date('Y-m-d-H:i:s'),				
										'created_at'=> date('Y-m-d-H:i:s'),	
									  );
							try{
								$resp =  $wpdb->insert($ts_traffic_leads,$insert);
								if($wpdb->insert_id) {
									$post_id= $wpdb->insert_id;
									//ts_save_video_to_server($post_id);
									//echo 'success';
									$message = '<div class="alert alert-success">Emails saved successfully</div>';
								}else{
									//print_r($wpdb->last_error);
									$message ='<div class="alert alert-danger">'.$wpdb->print_error().'</div>';
									//echo $wpdb->print_error();
								}
							}catch(\Exception $e){
								//print_r($e->getMessage());
								$message ='<div class="alert alert-danger">'.$e->getMessage().'</div>';
								//die('ERROR');
							}							
						}
						//echo"<pre>";print_r($data[$c]);echo"</pre>";					
						//echo $data[$c] . "<br />\n";
					}
			    }
			    fclose($handle);
			}	
		}	
       		
	}
	 echo $message;
}

function wphw_check_valid_email($email){
    $regex = '/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$/'; 
    $value = (preg_match($regex, $email))?true:false;
	return $value;
}
if(isset($_POST['listid_export'])){
	$listid = $_POST['listid_export'];
	//echo"<pre>";print_r($listid);echo"</pre>";
	$ts_traffic_leads = $wpdb->prefix . 'ls_traffic_leads';
	
	$filename = 'list_email_csv_' . time() . '.csv';

	$header_row = array('Email',);
    $data_rows = array();
	$leads = $wpdb->get_results("SELECT * FROM ".$ts_traffic_leads." WHERE listid = '".$listid."' ORDER BY id DESC");
	//echo"<pre>";print_r($leads);echo"</pre>";
	if (!empty($leads)){
		foreach($leads as $k=>$lead){
	        if(!empty($lead->email)){
				//echo"<pre>";print_r($lead->email);echo"</pre>";
				$row_email = array($lead->email);
				$data_rows[] = $row_email;
			}			
			
		}
	}
	
	//die;
	ob_end_clean ();
	$fh = @fopen( 'php://output', 'w' );
	header( "Content-Disposition: attachment; filename={$filename}" );
	fputcsv( $fh, $header_row );
	foreach ( $data_rows as $data_row ){
		fputcsv( $fh, $data_row );
	}
	exit(); 


}



if(isset($_POST['smtp_settings'])){
	//$listid = $_POST['listid_export'];
	//echo"<pre>";print_r($_POST);echo"</pre>";
	$wpts_smtp = $_POST['wpts_smtp'];
	update_option('wpls_smtp_settings',$wpts_smtp);
	echo '<div class="alert alert-success">SMTP settings saved successfully</div>';
	
}	

if(isset($_POST['save_optinform'])){

	$ts_traffic_optin_forms = $wpdb->prefix . 'ls_traffic_optin_forms';
    $insert = array(
				'listid' => $_POST['ts_optin_form']['listid'],
                'name'   => $_POST['ts_optin_form']['title'],				
				'content'=> serialize($_POST['ts_optin_form']),
                'updated_at'=> date('Y-m-d-H:i:s'),				
				'created_at'=> date('Y-m-d-H:i:s'),	
	          );
	try{
		$resp =  $wpdb->insert($ts_traffic_optin_forms,$insert);
		if($wpdb->insert_id) {
			$post_id= $wpdb->insert_id;
			//ts_save_video_to_server($post_id);
			//echo 'success';
			echo'<div class="alert alert-success">Form saved successfully</div>';
		}else{
			//print_r($wpdb->last_error);
			echo'<div class="alert alert-danger">'.$wpdb->print_error().'</div>';
			//echo $wpdb->print_error();
		}
	}catch(\Exception $e){
		//print_r($e->getMessage());
		echo'<div class="alert alert-danger">'.$e->getMessage().'</div>';
		//die('ERROR');
	}	
}

if(isset($_POST['update_optinform'])){
	$ts_traffic_optin_forms = $wpdb->prefix . 'ls_traffic_optin_forms';
	//echo"<pre>";print_r($_POST);echo"</pre>";
    $data = array(
				'listid' => $_POST['ts_optin_form']['listid'],
                'name'   => $_POST['ts_optin_form']['title'],				
				'content'=> serialize($_POST['ts_optin_form'])
	          );
	$where = array('id'=>$_POST['formid']);	
    //echo"<pre>";print_r($data);echo"</pre>";	
	try{
		$resp = $wpdb->update($ts_traffic_optin_forms, $data, $where );
		//echo"<pre>";print_r($resp);echo"</pre>";
		if($resp) {
			echo'<div class="alert alert-success">Form updated successfully</div>';
		}
	}catch(\Exception $e){
		echo'<div class="alert alert-danger">'.$e->getMessage().'</div>';
	}	
}

if(isset($_POST['save_optinformsettings'])){
	//$listid = $_POST['listid_export'];
	//echo"<pre>";print_r($_POST);echo"</pre>";
	$ts_optin_form_box = $_POST['ts_optin_form_box'];
	update_option('ls_optin_form_box',$ts_optin_form_box);
	
	$ts_optin_form_box_id = $_POST['ts_optin_form_box_id'];
	update_option('ls_optin_form_box_id',$ts_optin_form_box_id);	
	echo '<div class="alert alert-success">Optin Form settings saved successfully</div>';
	
}
if(isset($_POST['save_rescuesettings'])){
	//$listid = $_POST['listid_export'];
	//echo"<pre>";print_r($_POST);echo"</pre>";
	$ts_traffic_rescue = $_POST['ts_traffic_rescue'];
	update_option('ls_traffic_rescue',$ts_traffic_rescue);
	
	$ts_traffic_rescue_links = $_POST['ts_traffic_rescue_links'];
	//echo"<pre>";print_r($ts_traffic_rescue_links);echo"</pre>";
	update_option('ls_traffic_rescue_links',serialize($ts_traffic_rescue_links));	
	
	echo '<div class="alert alert-success">Settings saved successfully</div>';
	
}

function tsisEmail($email) {
     if(@eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $email)) {
          return true;
     } else {
          return false;
     }
}

if(isset($_POST['get_post_video'])){
	global $wpdb;
	//echo"<pre>";print_r($_POST);echo"</pre>";
	if(isset($_POST['video_post']) && $_POST['video_post']!=''){
		//$myposts = get_post($_POST['video_post']);
		//echo"<pre>";print_r($myposts);echo"</pre>";
		$wizard_url = $_POST['video_post'];
		$data=array();
		$data['status']='ok';
		$data['url']=$wizard_url;			
        try {
			$context = stream_context_create(
				array(
					"http" => array(
						"header" => "User-Agent: Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/50.0.2661.102 Safari/537.36"
					)
				)
			);			
			$homepage = @file_get_contents($wizard_url, false, $context);		
			//preg_match_all("/([a-z\-_0-9\/\:\.]*\.(jpg|jpeg|png))/i", $homepage, $matches);
			preg_match_all('/<img(.*?)src=("|\'|)(.*?)("|\'| )(.*?)>/s', $homepage, $matches);
			//echo"<pre>";print_r($matches);echo"</pre>";

			$i=1;
			$matchess[0] = array_unique($matches[3]);
			foreach($matchess[0] as $val) {
			    //echo"<pre>";print_r($val);echo"</pre>";
				//if($i<=20){   
					$pos = strpos($val,"/"); 
					//echo"<pre>";print_r($pos);echo"</pre>";
					//$link = substr($val,1,-1);
					
					//echo"<pre>";print_r($link);echo"</pre>";
					$link =$val;
					
					$path      = parse_url($link, PHP_URL_PATH);  
					//echo"<pre>";print_r($path);echo"</pre>";				
					$extension = pathinfo($path, PATHINFO_EXTENSION);			 
					$fname   = pathinfo($path, PATHINFO_FILENAME);
					//echo"<pre>";print_r($fname);echo"</pre>";
					
					$pattern = "/(background|favicon)/i";
					$fmatch =  preg_match_all($pattern, $fname);
					//echo"<pre>";print_r($fmatch);echo"</pre>";
					if($fmatch==0){
						//echo"<pre>";print_r($link);echo"</pre>";
					if($pos == 1 || $pos == 0 || $pos == ''){
						//$data['images'][]="http://domain.com".$link;
						//echo '<img class="img_responsive" src="http://domain.com'.$link.'" alt="" />';
					}else{
						

						//echo"<pre>";print_r($extension);echo"</pre>";
						if($extension=='jpg' || $extension=='png' || $extension=='jpeg'){
						//if($extension=='png'){
							//if($this->url_exists($link)){
							//if(is_file($link)){
								$data['images'][]=$link;
								$i++;
							//}
							//}
						}
						//echo '<img class="img_responsive" src="'.$link.'" alt="" />';
						//echo $link;

					}
					}			
				//}			
			}
        } catch (ModelNotFoundException $exception) {
            return back()->withError($exception->getMessage())->withInput();
		}		
		
	}
}	

if(isset($_REQUEST['action']) && $_REQUEST['action']=='tsrun'){
if(isset($_REQUEST['vid']) && $_REQUEST['vid']!=''){
	$vid = $_REQUEST['vid'];
	$results = $wpdb->get_row( "SELECT * FROM {$wpdb->prefix}ls_videos WHERE id = {$vid}", ARRAY_A  );
	//echo"<pre>";print_r(unserialize($results['slides']));echo"</pre>";
	
	$data = base64_encode(serialize($results));
    $siteip = $_SERVER['SERVER_ADDR'];
	$url    = home_url();
	$apikey = "guriaulakh";

	//$url1 = "https://affilipress.net/ffmpeg/index.php?ali_action=activate_license&apikey=guriaulakh&url=google.com&ip=127.11.24.11&data=".$data;
	$url1 = "https://profitenigma.com/ffmpeg/save_request.php?action=save_request&apikey=".$apikey."&vid=".$vid."&url=".$url."&ip=".$siteip."&data=".$data;
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url1);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$resp = curl_exec($ch);
	//echo"<pre>";print_r($resp);echo"</pre>";
	$response= json_decode($resp);
	//echo"<pre>";print_r($response);echo"</pre>";

	curl_close($ch);
	if(isset($response->status) && $response->status=='success'){
		echo'<div class="alert alert-success">Creating video is in process. Please wait for 2 mintues.</div>';
	}
	if(isset($response->status) && $response->status=='fail'){
		return false;
	}	
}	
}


function ls_pagination($ts_traffic_lists,$pagenum,$limit=10,$where=''){
	$aff_total='';
	$num_of_pages='';
	$page_links='';

	global $wpdb;
	$aff_total = $wpdb->get_var( "SELECT COUNT('id') FROM ". $ts_traffic_lists." $where" );
	$num_of_pages = ceil( $aff_total / $limit );

	$page_links = paginate_links( array(
		'base' => add_query_arg( 'pagenum', '%#%' ),
		'format' => '',
		'prev_text' => __( '&laquo;', 'text-domain' ),
		'next_text' => __( '&raquo;', 'text-domain' ),
		'total' => $num_of_pages,
		'current' => $pagenum,
		'add_args'  => array()
	) );

	if ( $page_links ) {
		return '<div class="ts-pagination">' . $page_links . '</div>';
	}
}

function auto_resp_automatic_email_cron_test()
{
	global $wpdb;
	
	$option_name = 'wpls_auto_resp_setting';
	$listid = get_option( $option_name );
	
	if(!empty($listid))
	{
		$ls_list_builder = $wpdb->prefix."list_builder";
		$list_builder = $wpdb->get_results ("SELECT * from  " . $ls_list_builder);
		
		foreach($list_builder as $list_builders)
		{
			$ss = $list_builders->email;
			echo $ss."<br/>";
			$ls_traffic_lists = $wpdb->prefix."ls_traffic_leads";
			$ls_lists = $wpdb->get_results ("SELECT * from  " . $ls_traffic_lists."  WHERE listid = '".$listid."' AND email = '".$ss."' ORDER BY id DESC");
			
			if(count($ls_lists) > 0) 
			{ 
			}
			else
			{
				$ls_email_datas=array(
									'listid' => $listid,
									'email' => $list_builders->email,
									'updated_at' => date('Y-m-d-H:i:s'), 
									'created_at' => date('Y-m-d-H:i:s'), 
								   );

				$wpdb->insert( $ls_traffic_lists, $ls_email_datas);
			}
		}
	}
}

if(isset($_POST['send_mails_list'])){
	$email_array=array();
	$listid = $_POST['listid'];
	//echo"<pre>";print_r($listid);echo"</pre>";
	$ts_traffic_leads = $wpdb->prefix . 'ls_traffic_leads';

	$leads = $wpdb->get_results("SELECT * FROM ".$ts_traffic_leads." WHERE listid = '".$listid."' ORDER BY id DESC");
	//echo"<pre>";print_r($leads);echo"</pre>";
	if (!empty($leads)){
		foreach($leads as $k=>$lead){
	        if(!empty($lead->email)){
				$email_array[] = $email = $lead->email;
				//echo"<pre>";print_r($lead->email);echo"</pre>";
			}
		}	
	}	
	
	//echo"<pre>";print_r($email_array);echo"</pre>";

	$wpts_smtp = get_option('wpls_smtp_settings',false); 
	//echo"<pre>";print_r($wpts_smtp);echo"</pre>";
	

	require_once("class/PHPMailer-master/src/PHPMailer.php");
	require_once("class/PHPMailer-master/src/SMTP.php");
	require_once("class/PHPMailer-master/src/Exception.php");


	$mail = new PHPMailer\PHPMailer\PHPMailer();

	$smtp_host_name  = $wpts_smtp['host'];
	$smtp_auth       = $wpts_smtp['auth'];
	$smtp_username   = $wpts_smtp['username'];
	$smtp_password   = $wpts_smtp['password'];
	$smtp_encrypt    = $wpts_smtp['encrypt'];
	$smtp_port       = $wpts_smtp['port'];
	$smtp_from_email = $wpts_smtp['from_email'];
	$smtp_from_name  = $wpts_smtp['from_name'];

	$subject = $_POST['email_subject'];
	
//echo"<pre>";print_r($_POST['email_content']);echo"</pre>";		
	$message = preg_replace('/\\\\/', '', $_POST['email_content']);		
	$unsubid  = get_option('listsmasher_unsubscribe',true);
	$siteurl  = esc_url( get_page_link( $unsubid ) );
//echo"<pre>";print_r($message);echo"</pre>";	
//die;

	if(!empty($smtp_host_name) && !empty($smtp_auth) && !empty($smtp_username) && !empty($smtp_password) && !empty($smtp_encrypt) && !empty($smtp_port) && !empty($smtp_from_email))
	{
		$mail->IsSMTP();
		$mail->SMTPAuth = TRUE;
		//$mail->SMTPDebug = 2;
		$mail->SMTPSecure = $smtp_encrypt;
		$mail->Port = $smtp_port;  
		$mail->Username = $smtp_username;
		$mail->Password = $smtp_password;
		$mail->Host = $smtp_host_name;
		$mail->Mailer = "smtp";
		$mail->SetFrom($smtp_from_email,$smtp_from_name);
		$mail->AddReplyTo($smtp_from_email,$smtp_from_name);

		foreach($email_array as $email_arrays){
			$mail->addAddress($email_arrays);
			
			$message2 = '<br><br><p><a target="_blank" href="'.$siteurl.''.$listid.'/'.$email_arrays.'">Unsubscribe</a></p>';
			//echo"<pre>";print_r($message);echo"</pre>";				
        
			$mail->IsHTML(true);		
			$content = nl2br($message.$message2); 
			$mail->Subject = $subject;
			$mail->MsgHTML($content);
			
			if(!$mail->Send()){ 
				$msg = '<div class="wrap">
					<div class="error">Problem sending email . Please check the SMTP settings or the email list.</div>
				</div>';
			}else{ 
				$msg = '<div class="wrap">
					<div class="updated">Email sent successfully.</div>
				</div>';
			}
			$mail->ClearAddresses();
            unset($message2);
			unset($content);
	    }		
	} 
	else 
	{ ?>
		<div class="wrap">
			<div class="error">Please setup the settings</div>
		</div>
	<?php 
	} 
	
	echo $msg;
	?>		
	<script>
	jQuery(function() {
		setTimeout(function() {
			  jQuery('.updated').fadeOut('slow');
			}, 8000); // <-- time in milliseconds
		setTimeout(function() {
			  jQuery('.error').fadeOut('slow');
			}, 8000); // <-- time in milliseconds
	});
	</script>
    <?php    	
	
}	