<?php
/**
 * Define the internationalization functionality.
 *
 * Loads and defines the internationalization files for this plugin
 * so that it is ready for translation.
 *
 * @package    litesmash
 * @subpackage litesmash/includes
 * @author     litesmash <contact@litesmash.com>
 */
class LiteSmash_i18n {

	public function load_plugin_textdomain() {

		load_plugin_textdomain(
			'litesmash',
			false,
			dirname( dirname( plugin_basename( __FILE__ ) ) ) . '/languages/'
		);

	}



}
