<?php // Silence is golden
global $wpdb;
require TS_PLUGIN_PATH.'view/header.php';
require TS_PLUGIN_PATH.'traffic/functions.php';


$ts_traffic_optin_forms = $wpdb->prefix."ts_traffic_optin_forms";
$forms = $wpdb->get_results ("SELECT * from  " . $ts_traffic_optin_forms."  ORDER BY id DESC");

$ts_optin_form_box    = get_option('ts_optin_form_box',false);
$ts_optin_form_box_id = get_option('ts_optin_form_box_id',false);


$ts_traffic_rescue = get_option('ts_traffic_rescue',false);
$ts_traffic_rescue_links = get_option('ts_traffic_rescue_links',false);	

?>
<div class="ts_main_wrap">
	<div class="ts_container">
		<div class="ts_main">
            <h2>Manage Traffic rescue
			    <!--<a class="button button-primary btn_right" href="admin.php?page=ts-email-traffic" >Email Traffic</a>
				<a class="button button-primary btn_right" href="admin.php?page=ts-email-traffic&module=lists" style="margin-right:5px;"> Manage Lists</a>-->
		    </h2>
		    <div class="ts_main_content">
				<h4><b>Traffic Rescue Settings</b></h4>
				<form id="traffic_rescue_form" action="" method="post"  enctype="multipart/form-data">
				<div class='ts-form-container'>
					<input type="hidden" class="form-control"  name="type" value="custom" >
					<div class="form-group row">
						<label class="col-lg-2" for="ts_traffic_rescue">404 Traffic Rescue</label>
						<div class="col-lg-5">
							<input type="checkbox" class="form-control" id="ts_traffic_rescue" name="ts_traffic_rescue" value="yes" <?php if($ts_traffic_rescue == 'yes') { echo " checked "; } ?> style="width:30px;height:30px;padding:2% !important;" />
							<label>Enable/Disable</label>
						</div>
					</div>						
					<div id="links">
					    <?php 
						$rescue_links = unserialize($ts_traffic_rescue_links);
						if(!empty($rescue_links)){
						$k=0;
						foreach($rescue_links as $rescue_link){
							//echo"<pre>";print_r($rescue_link);echo"</pre>";
							$k++;
						?>
						<div id="link_<?php echo $k; ?>" class="form-group row links">
							<label class="col-lg-2" for="ts_traffic_rescue_links">Redirect Link</label>
							<div class="col-lg-5">
								<input type="url" class="form-control input" id="ts_traffic_rescue_links" name="ts_traffic_rescue_links[<?php echo $k; ?>][url]" data-name="url" value="<?php echo $rescue_link['url']; ?>" placeholder="https://example.com" />
							</div>
							<div class="col-lg-1">
								<img class="delete_link" data-id="<?php echo $k; ?>" src="<?php echo TS_PLUGIN_URL; ?>public/img/delete.png" style="width:30px;cursor: pointer;">
							</div>
						</div>
						<?php } }else{ $k=1; ?>
						<div id="link_<?php echo $k; ?>" class="form-group row links">
							<label class="col-lg-2" for="ts_traffic_rescue_links">Redirect Link</label>
							<div class="col-lg-5">
								<input type="url" class="form-control input" id="ts_traffic_rescue_links" name="ts_traffic_rescue_links[<?php echo $k; ?>][url]" data-name="url" value="" placeholder="https://example.com" />
							</div>
							<div class="col-lg-1">
								<img class="delete_link" data-id="<?php echo $k; ?>" src="<?php echo TS_PLUGIN_URL; ?>public/img/delete.png" style="width:30px;cursor: pointer;">
							</div>
						</div>
						
						<?php } ?>
                    </div>						
					<div class="form-group row">
					    <label class="col-lg-2" for="ts_optin_form_button_text"></label>
						<div class="col-lg-1">
							<a type="button" id="add_link" class="button button-success add_link">+ Add link</a>
						</div>
                        <div class="col-lg-4">						
							<div style="display:none;padding:5px;" class="alert alert-danger link_limit"></div>
						</div>
					</div>		
					<!--<div class="form-group row">
					    <label class="col-lg-2" for="ts_optin_form_button_save"></label>
						<div class="col-lg-10 ml-auto css-control css-control-primary css-switch" for="wizard-progress-terms">
							<button type="submit" name="save_optinformsettings" class="button button-primary d-none" data-wizard="finish">
								<i class="fa fa-check mr-5"></i> Save Settings
							</button>
						</div>
					</div>-->
				</div>
				<br>
				<div class="form-group row">
					<div class="col-lg-10 ml-auto css-control css-control-primary css-switch" for="wizard-progress-terms">
						<button type="submit" name="save_rescuesettings" class="button button-primary d-none" data-wizard="finish">
							<i class="fa fa-check mr-5"></i> Save Settings
						</button>
					</div>
				</div>
                </form>					
		    </div>
		</div>
    </div>
</div>
<script>
jQuery(document).ready(function($) {
	$('.add_link').click(function(){
        var x = $( "#links .links" ).length;
		//alert(x);
		$(".link_limit").hide();
		if(x<5){
		x++;
		//alert(x);
		var clonee = $("#links .links:last").clone();
		console.log(clonee);
		clonee.find('.input').attr('name', function( i, val ){
			i++;
			//alert(x);
            var name = $(this).data('name');
			return 'ts_traffic_rescue_links['+x+']['+name+']';
		});
		clonee.attr('id','link_'+x);
		clonee.find('.delete_link').attr('data-id',x);
		$('#links').append(clonee);
		//$('.js-colorpicker-enabled').colorpicker();
        //$('.js-colorpicker').colorpicker();
		//$('#mtable tbody tr:last :checkbox').attr('checked',false);
		//$('#mtable tbody tr:last td:first').html($('#row').val());
		}else{
			$(".link_limit").show();
			$(".link_limit").text('You can not add more than 5 links.');
			
		}
	});
	
	$('body').on('click', '.delete_link', function(e) {
		if(confirm("Are you sure you want to delete this slide?")){
			var id = $(this).data('id');
			$("#link_"+id).remove();
		}else{
			e.preventDefault();
		}
	});
});	
</script>